using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using HBDotNet;
 
namespace TestLibrary
{
    [HBDevice("Clock")]
    [HBProperty("Current Time", ePropertyType.ptTime, "")]
    [HBProperty("Tick Every 5 Seconds", ePropertyType.ptBoolean, "No")]
    public class Class1 : HBDeviceBase
    {
        private Thread _thread;
 
        public override bool OnInit(bool enabled)
        {
            if (enabled) OnEnable();
            return base.OnInit(enabled);
        }
 
        public override void OnShutdown()
        {
            if (_thread != null) _thread.Abort();
            base.OnShutdown();
        }
 
        public override bool OnEnable()
        {
            _thread = new Thread(ThreadFunc);
            _thread.Start();
            return base.OnEnable();
        }
 
        public override bool OnDisable()
        {
            if (_thread != null) _thread.Abort();
            _thread = null;
            return base.OnDisable();
        }
 
        public void ThreadFunc()
        {
            while (true)
            {
                Thread.Sleep(1000);
                DateTime D = DateTime.Now;
                Properties[0].CurrentValue = D.ToString();
                if ((D.Second % 5) == 0)
                {
                    if (Properties[1].CurrentValue == "Yes") 
                            System.Diagnostics.Debug.WriteLine("BEEP");
                }
            }
        }
    }
}
